/*
 *  DEBUG, {akii-root}/src/debug.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _AKII_DEBUG_H_
#define _AKII_DEBUG_H_ 1

#include <stdio.h>

enum edbg {
/*variables.c */
    dbg_getvar,
    dbg_getvarifp,
    dbg_getnumvar,
    dbg_parsedollar,
    dbg_dollar,
    dbg_braces,
    dbg_freevarlist,
    dbg_freenumvarlist,
    dbg_setvar,
    dbg_setnvar,
    dbg_gettoretlen,
    dbg_freeonlist,
    dbg_freetimerlist,
/*expression.c */
    dbg_getoperand,
    dbg_dokif,
    dbg_readkif,
    dbg_readkiffv,
    dbg_readkifop,
    dbg_milyenkifez,
    dbg_readkifinfix,
    dbg_freeinfkif,
    dbg_mkpostfix,
    dbg_freekiffa,
    dbg_mkkiffa,
    dbg_dtos,
    dbg__valamilyen_op,
/*interpreter.h */
    dbg_freepar,
    dbg_read_timer,
    dbg_read_on,
    dbg_read_return,
    dbg_read_do,
    dbg_read_while,
    dbg_read_else,
    dbg_read_if,
    dbg_read_for,
    dbg_read_foreach,
    dbg_read_alias,
    dbg_read_brkcnt,
    dbg_read_kif,
    dbg_milyenparancs,
    dbg_do_alias,
    dbg_do_if,
    dbg_do_return,
    dbg_do_do,
    dbg_do_while,
    dbg_do_for,
    dbg_do_foreach,
    dbg_do_on,
    dbg_do_timer,
    dbg_dooneparancs,
    dbg_doparancssor,
    dbg_readparancs,
/*commands.c */
    dbg_callfv,
/*regexp.c */
    dbg_regprobal,
    dbg_regszavak,
    dbg_regqszavak,
/*screen.c */
    dbg_parsestatus,
/*main.c */
    dbg_elemez,
    dbg_sendline,
    dbg_szin,
    dbg_lookfortimers,
    dbg_loadakiirc,
/*MODOSITASOK IDE: */
    dbg_read_checkpoint,
    dbg_do_checkpoint,
    dbg_NORMALEXIT,
    dbg_sigsemmi,
/*ez az utolso! Hagyd igy! */
    dbg_last
};

extern FILE *dbgfp;

extern void startdbg(void);
extern void closedbg(void);
extern void dbgenter(int fv, char *megj);
extern void dbgleave(int fv);

#endif
