/*
 *  VARIABLES, {akii-root}/src/variables.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _VARIABLES_H_
#define _VARIABLES_H_ 1
#include "interpreter.h"
#include <time.h>
#include <sys/time.h>

#define VFLAG_NORMAL  001
#define VFLAG_BELSO   002
#define VFLAG_LOCAL   004
/*#define VFLAG_FOREACH 010 */

enum varenum {
    VAR_NORMAL, VAR_STRUCT, VAR_ALIAS, VAR_FV, VAR_VEZER, VAR_FOREACH
};
struct kif;
struct valtozo {
    char *nev;
    enum varenum tipus;		/*VAR_... */
    char *ertek;		/* erteke, (struct valtozo*), vagy (struct parancs*), vagy (void (*)(struct valtozo*)) */
    struct valtozo **parent, *next, *prev;
    char notdeletable;
    int flag;			/*milyen valtozo: belso, lokalis, altalanos */
};

struct onstr {
    char *nev;
    char tipus;
    char tiltott;
    int szint;
    int kifek;
    char **regkifek;
    struct parancs *par;
    struct onstr *prev, *next;
    int justmark;
};
struct timerstr {
    char *nev;
    char tipus;
    char tiltott;
    int ido;
    time_t last;
    struct parancs *par;
    struct timerstr *prev, *next;
};

extern struct valtozo *varlist;	/*user valtozok */
extern struct valtozo *bivarlist;	/*belso valtozok */
extern struct valtozo *localvars[1024];		/*lokalis valtozoknak... */
extern int locallevel;		/*lokalis szint (callfv noveli) */

extern char **numvarlist;	/*aktualis parameter szavai TOMB */
extern char **chvarlist;	/*regexp behelyettesitesei TOMB */
extern char **mchvarlist;
extern int kerdojel;		/*ON-nal melyik kif illeszkedett */
extern int mkerdojel;

extern struct onstr *onlist;	/*ON strukturak lancolata */
extern struct onstr *onsendlist;	/*ONSEND strukturak lancolata */

extern struct timerstr *timerlist;	/*TIMER strukturak lancolata */

extern struct valtozo *getvar(struct valtozo **, char **, int, int);
extern struct valtozo *getvarifp(struct valtozo **, char **);
extern struct valtozo *getvar2(char *);
extern char *getnumvar(char **, int, int);
extern char *parsedollar(char *);
extern int dollar(char **, char *);
extern void braces(char **, char *, char, char);

extern int freevarlist(struct valtozo *, int);
extern void freenumvarlist(char ***);

extern int istrcmp(char *, char *);
extern int istrncmp(char *, char *, int);

extern void initvariables(char *, int, char *, char *, char *, int);
extern void donevariables_fvs(void);

extern struct valtozo *setvar(struct valtozo *, char *);
extern struct valtozo *setnvar(struct valtozo *, char *, int);
extern struct valtozo *setivar(struct valtozo *, long int);
extern struct valtozo *newfv(char *, void (*fv) (struct valtozo *));

extern void freeonlist(struct onstr *);

extern void freetimerlist(void);

extern struct valtozo *akii_prompt;
extern struct valtozo *akii_sortby;
extern struct valtozo *akii_termwidth;
extern struct valtozo *akii_termheight;
extern struct valtozo *akii_winsize;
extern struct valtozo *akii_usewin;
extern struct valtozo *akii_inputidle;
extern struct valtozo *akii_floodprotect;
extern char sortby;

extern char *use_list[100];
extern int usenum;
extern int adduse(char *);
extern int inuse(char *);
extern int deluse(char *);

extern int delquote;
extern int dontquote;
extern int varflag;

extern char *blockname;

#endif
